/**
 * @file
 * Client side encryption of user contact forms
 */
$(document).ready( function() {
  // Disallow sending copies for now since we can only encrypt to one key.
  $('div#edit-copy-wrapper').toggle();
  // Enable the encrypt button
  $('input#edit-encrypt').removeAttr("disabled");

  // Bind the encryption behaviour to the Encrypt and Send button
  $('input#edit-encrypt').click( function(event) {

    // Initialize a form variable we'll use a couple of times
    var cryptForm = $(this).parents('form');

    // Don't submit the form yet
    event.preventDefault();

    // Use a throbber
    progressElement = $('<div class="ahah-progress ahah-progress-throbber"><div class="throbber">&nbsp;</div></div>');
    $('.throbber', progressElement).after('<div class="message">' + Drupal.settings.pgpContactMessage + '</div>')
    cryptForm.after(progressElement);

    // Fetch the public key from Drupal
    var pgpKey = $.post(
      Drupal.settings.basePath + 'user/' + Drupal.settings.pgpContactUser + '/ajax-key', 
      { token: $('input#edit-form-token').val() }, 
      function (data) {

      // Once we have the key, perform the encryption
      pgpKey = Drupal.parseJson(pgpKey.responseText);
      pgpKey = new getPublicKey(pgpKey.publicKey);

      keyType = -1;
      if (pgpKey.type == "RSA") keyType = 0;
      if (pgpKey.type == "ELGAMAL") keyType = 1;
      if (keyType == -1) throw('Invalid key type: ' . pgpKey.type);
      var cryptedText = doEncrypt(pgpKey.keyid, keyType, pgpKey.pkey, $('textarea#edit-message').val());

      // Replace the text in the textarea with the encrypted text
      $('textarea#edit-message').val(cryptedText);

      // Submit the form
      cryptForm.submit();
    });
  });
});
